Subject: bug#21695: 25.0.50; Change most occurrences of `setq' in Emacs manual to `customize-set-variable'? Really?

From: Gregory Heytings <[email-masked]>
Date: Sun, 12 Sep 2021 09:54:51 +0000

>> I don't know if this is during of after the startup.  At least it is 
>> visible when startup has completed.
>
> You need a much larger init file with several setq like this.  The 
> warnings usually fly by you without giving enough chance to read them.
>

That's not what I see, after the startup has completed I see a *Warnings* 
buffer in the lower half of the frame.  See attached screenshot.

>>> Also, warnings.el is not preloaded, so this call could barf in some 
>>> valid cases.
>>
>> That's not what I see:
>>
>> ;;;###autoload
>> (defun display-warning (type message &optional level buffer-name)
>
> That's autoloaded, not preloaded; the latter is in loadup.el.
>

Hmm, then I don't see what you mean.  I did not know that there is a 
difference between "autoload" and "preload".

>
> Is this multiplicative, i.e. if you perform it many times, does it 
> indeed take 20% longer overall?  If so, this is not an acceptable 
> performance hit, I think, not for such a minor feature.
>

The "(get sym 'custom-set)" call adds about ~8 nanoseconds to each call to 
setq.  I don't see how this could be avoided, if the idea is to display a 
warning when setq is used when customize-set-variable should be used 
instead.  Of course every new feature comes at a cost.

Perhaps a new defcustom could be created, e.g. customize-warn-setq, 
defaulting to t, to make it possible to avoid that call to "(get sym 
'custom-set)"?